//filter flags
#define K_MOB 0
#define K_OBJ 1
#define K_TURF 2
#define K_AREA 4
#define K_ATOM 8
#define K_NULL 16
#define K_NUM 32
#define K_DECIMAL 64
#define K_TEXT 128
#define K_MATOM 256

//i_type flags
#define K_PASSWORD 1
#define K_MESSAGE 2
#define K_NOSCROLL 4
#define K_RADIO 8

var/list/alpha=list("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z")
var/list/numbers=list("0","1","2","3","4","5","6","7","8","9")


proc/K_Input(client/C, message, title, default, list/options, i_type=K_NOSCROLL, filter, duration, size="350x125;10/20", style)
	if(C)
		if(ismob(C))
			var/mob/M=C
			C=M.client
		if(!(istype(C)))return
	else return
	var/K_Input/K=new(C)
	K.Display(message, title, default, options? options.Copy() : options, i_type, filter, size, style)
	while(!K.response)
		if(duration<0)break
		sleep(2)
		if(duration)duration-=2
	.=K.response
	if(K.response=="null")
		.=null
	if(findtext(K.response,"atom_"))
		.=locate(copytext(K.response,6))
	if(K.target)
		K.target<<browse(null,"[K.window_stats]")
		del K

K_Input
	var
		response
		filter_type
		input_type
		client/target
		code
		window_stats

	New(C)
		var/client/O=C
		target=O

	proc
		Display(message, title, default, list/options, i_type, filter, size, style)
			if(!i_type)return
			var/html={"
[(i_type & K_NOSCROLL)? "<body scroll=no>" : ""]
[style? "<style>[style]</style>" : ""]
[title? "<title>[title]</title>" : ""]
[message]<br>
<br>
<b></b>
"}
			html+="<form action='?src=\ref[src]'>"
			if(options)
				options=Filter(options,filter)
				if(i_type & K_RADIO)
					for(var/o in options)
						html+="<input type=radio [(o==default)? "checked=checked" : ""] name=k_input value=[(istype(o,/atom))? "atom_\ref[o]" : "[o]"]>[istype(o,/atom)? "\icon[o]" : ""][o]<br>"
				else
					html+="<select name=k_input>"
					for(var/o in options)
						html+="<option value=[(istype(o,/atom))? "atom_\ref[o]" : "[o]"] [(o==default)? "selected=selected" : ""]>[o]</option>"
					html+="</select>"
			else if(i_type & K_PASSWORD)
				html+="<input type=password name=k_input [default? "value=[default]" : ""]>"
			else if(i_type & K_MESSAGE)
				html+="<textarea name=k_input rows=[copytext(size,findtext(size,";")+1,findtext(size,"/"))] cols=[copytext(size,findtext(size,"/")+1)]></textarea>"
			else
				html+="<input type=text name=k_input [default? "value=[default]" : ""]>"
			html+="<input type=submit value=Ok>"
			html+="<input type=hidden name=src value='\ref[src]'>"
			if(filter & K_NULL)
				html+="<input type=button name=k_input value=cancel>"
			html+="</form>"
			code=html
			if(filter)filter_type=filter
			input_type=i_type
			window_stats="window=\ref[src][size? ";size=[copytext(size,1,findtext(size,";"))]" : ""]"
			spawn() target<<browse(html,window_stats)

		Filters(filter)
			var/list/filters=new
			if(filter & K_MOB)
				filters+=/mob
			else if(filter & K_OBJ)
				filters+=/obj
			else if(filter & K_TURF)
				filters+=/turf
			else if(filter & K_AREA)
				filters+=/area
			else if(filter & K_ATOM)
				filters+=/atom
			else if(filter & K_TEXT)
				filters+="text"
			else if(filter & K_NUM)
				filters+="num"
			else if(filter & K_MATOM)
				filters+=/atom/movable
			return filters

		Filter_Check(object,list/filters)
			var/invalid=0
			for(var/types in filters)
				if(((types=="text") && istext(object)) || ((types=="num") && isnum(object)) || istype(object,types))
					invalid=0
					break
				else
					invalid=1
			return invalid

		Filter(list/filter_list,filter)
			if(filter)
				var/list/filters=Filters(filter)
				for(var/o in filter_list)
					if(Filter_Check(o,filters))
						filter_list-=o
			return filter_list

		Process_Response(answer)
			if((!answer) || (answer=="cancel"))return "null"
			.=answer
			if(filter_type & K_NUM)
				var/length=length(answer)
				var/decimal=filter_type & K_DECIMAL
				for(var/i = 1 to length)
					var/number=copytext(answer,i,i+1)
					if(number in alpha)
						return Error("You can only input digits!")
					else if(number=="." && !decimal)
						return Error("Decimals are not allowed in this input field!")


		Error(error_msg)
			var/find=findtext(code,"<b></b>")+3
			if(target)target<<browse("[copytext(code,1,find)][error_msg][copytext(code,find)]",window_stats)

	Topic(href, params[])
		if(response || (usr.client != target))return
		response=Process_Response(params["k_input"])